<?php
class EvAdBanner_Add extends EvAdBanner_Admin {
    private static $ancora_pag;
    private static $pagina = 'add';


    final public function __construct() {
        if ((isset($_GET['page']) and $_GET['page'] === EvAdBanner_Admin_Init::getPagesName(self::$pagina) or
                strpos($_SERVER['SCRIPT_NAME'], 'options.php')) and is_admin()) {
            parent::__construct();
            add_action('admin_init', array($this, 'form_pagina_' . self::$pagina));

            if (strpos($this->nome_pagina_corrente, '-' . self::$pagina) !== false) {
                add_action('admin_enqueue_scripts', array($this, 'carica_stili_e_script'));
            }

            self::$ancora_pag = EvAdBanner_Admin_Init::getPagesName(self::$pagina);
        }
    }

    final public function carica_stili_e_script() {
        self::carica_stili();
        self::carica_scirpt();
    }
    private function carica_stili() {
        wp_register_style (EVADBANNER_PREFISSO.self::$ancora_pag, EVADBANNER_PLUGIN_URL.'css/'.self::$ancora_pag.
            '.css', array(), EVADBANNER_CSS_ADM_HOME);
        wp_enqueue_style (EVADBANNER_PREFISSO.self::$ancora_pag, false, array(), EVADBANNER_CSS_ADM_HOME);

//        wp_add_inline_style( EVADBANNER_PREFISSO.self::$ancora_pag, self::stili_personalizzati() );
    }
    private static function carica_scirpt() {
        wp_register_script (EVADBANNER_PREFISSO.self::$ancora_pag, EVADBANNER_PLUGIN_URL.'js/'.self::$ancora_pag.
            '.js', array('jquery'),EVADBANNER_JS_ADM_HOME);
        wp_enqueue_script(EVADBANNER_PREFISSO.self::$ancora_pag, false, array(), EVADBANNER_JS_ADM_ADD);

    }
    private function stili_personalizzati() {
        $css_add  = '.fmt-eab-interruttore-banner {';
        $css_add .= 'background: url("'.EVADBANNER_PLUGIN_URL.'img/on.png") no-repeat scroll 0 0 rgba(0, 0, 0, 0);';
        $css_add .= '}';

        return $css_add;
    }

    public function form_pagina_add () {
        register_setting (
            self::$ancora_pag.'_gr',   // Option group
            self::$ancora_pag,
            array($this, 'sanitize_pag_'.self::$pagina)      // Sanitize
        );
    }

    /**
     * Questo metodo è invocato dalla classe "BorSerVal_Admin_Init - carica_menu_exec()" quando crea il menù del plugin
     *
     * e visualizza la pagina Home del plugin
     */
    public function visualizza_pagina_add ($contenuto=NULL) {
        include_once EVADBANNER_PLUGIN_DIR.'admin/'.self::$pagina.'_view.php';
    }

    public function sanitize_pag_add ($input) {
//        $messaggio = '';
//        if (isset($this->contenuto[0]['banner_esempio'])) {
//            $messaggio = '<h1>Banner di Esempio !</h1>';
//        }
//        foreach ($input as $chiave => $valore) {
//            $messaggio .= $chiave.': ';
//            if (is_array($valore)) {
//                foreach ($valore as $chiave2 => $valore2) {
//                    $messaggio .= '<br><p style="color: green;">'.$chiave2.': '.$valore2.'</p>';
//                }
//            } else {
//                $messaggio .= $valore.'<br><br>';
//            }
//        }
//        parent::aggiungi_messaggio_db('error', $messaggio);
//        return false;



        // EVENT NAME
        $tipo_mess = 'error';
        $messaggio = NULL;
        if (!isset($input['nome_evento']) or empty($input['nome_evento'])) {
            $messaggio = __('ERROR - Event Name is required.', EVADBANNER_ANCORA_TRAD);

            parent::aggiungi_messaggio_db($tipo_mess, $messaggio);

            return false;
        }

        $this->contenuto = array();
        // STATE BANNER
        if (isset($input['stato_banner'])) {
            $this->contenuto['stato_banner'] = sanitize_text_field($input['stato_banner']);
            unset($input['stato_banner']);
        } else {
            $this->contenuto['stato_banner'] = 'off';
        }

        // EXPIRATION DATE
        if (isset($input['expire_year']) and isset($input['expire_month']) and isset($input['expire_day'])) {
            if (!empty($input['expire_year'])) {
                if (empty($input['expire_month'])) {
                    $messaggio = __('ERROR - Please enter also the month.', EVADBANNER_ANCORA_TRAD);

                    parent::aggiungi_messaggio_db($tipo_mess, $messaggio);

                    return false;
                } elseif (empty($input['expire_day'])) {
                    $messaggio = __('ERROR - Please enter also the day.', EVADBANNER_ANCORA_TRAD);

                    parent::aggiungi_messaggio_db($tipo_mess, $messaggio);

                    return false;
                } else {
                    $this->contenuto['expire'] = sanitize_text_field($input['expire_year']).'-'.sanitize_text_field($input['expire_month']).
                        '-'.sanitize_text_field($input['expire_day']);
                }
            }
            unset($input['expire_year']);
            unset($input['expire_month']);
            unset($input['expire_day']);
        } else {
            $messaggio = __('ERROR -01- There is some error on inputs sended.', EVADBANNER_ANCORA_TRAD);

            parent::aggiungi_messaggio_db($tipo_mess, $messaggio);

            return false;
        }

        unset($input['submit']);
        if (!isset($input['immagine']) and isset($input['immagine_show'])) {
            unset($input['immagine_show']);
        }
//        $wpml = false;
//        if (is_plugin_active('sitepress-multilingual-cms/sitepress.php') and function_exists('icl_register_string')) {
//            $wpml = true;
//        }
        foreach ($input as $chiave => $valore) {
            $chiave = sanitize_key($chiave);
            if (!empty($valore)) {
                if ('link_sx' === $chiave or 'link_dx' === $chiave or 'immagine' === $chiave) {
                    $this->contenuto[$chiave] = esc_url_raw($valore);
                }/* elseif ('titolo' === $chiave or 'sottotitolo' === $chiave or 'descrizione' === $chiave or
                    'link_sx_titolo' === $chiave or 'link_dx_titolo' === $chiave) {
//                    if ($wpml) {
//                        icl_register_string(EVADBANNER_ANCORA_TRAD, 'FMT-'.$chiave, $valore);
//                    }
                    $this->contenuto[$chiave] = sanitize_text_field($valore);
                }*/ else {
                    $this->contenuto[$chiave] = sanitize_text_field($valore);
                }
            }
        }



        if (update_option(EVADBANNER_ANCORA_CONTENUTO, $this->contenuto)) {
            $tipo_mess = 'updated';
            $messaggio = __('Successfully saved !', EVADBANNER_ANCORA_TRAD).' - <a href="?page='.EvAdBanner_Admin_Init::getPagesName('home').'">'.
                __('go to preview', EVADBANNER_ANCORA_TRAD).'</a>';
        } else {
            $messaggio = __('Oops there was some error on saving, please try again.', EVADBANNER_ANCORA_TRAD);
        }

        if (isset($messaggio)) {
            parent::aggiungi_messaggio_db($tipo_mess, $messaggio);
        }
    }
}