<?php
class EvAdBanner_Home extends EvAdBanner_Admin {
    private static $ancora_pag;
    private static $pagina = 'home';


    final public function __construct() {
        if ((isset($_GET['page']) and $_GET['page'] === EvAdBanner_Admin_Init::getPagesName(self::$pagina) or
                strpos($_SERVER['SCRIPT_NAME'], 'options.php')) and is_admin()) {
            parent::__construct();
            add_action('admin_init', array($this, 'form_pagina_' . self::$pagina));

            if (strpos($this->nome_pagina_corrente, '-' . self::$pagina) !== false) {
                add_action('admin_enqueue_scripts', array($this, 'carica_stili_e_script'));
            }

            self::$ancora_pag = EvAdBanner_Admin_Init::getPagesName(self::$pagina);
        }
    }

    final public static function carica_stili_e_script() {
        self::carica_stili();
        self::carica_scirpt();
    }
    private static function carica_stili() {
        wp_register_style (EVADBANNER_PREFISSO.self::$ancora_pag, EVADBANNER_PLUGIN_URL.'css/'.self::$ancora_pag.
            '.css', array(), EVADBANNER_CSS_ADM_HOME);
        wp_enqueue_style (EVADBANNER_PREFISSO.self::$ancora_pag, false, array(), EVADBANNER_CSS_ADM_HOME);

        // AGGIUNGE I STILI PERSONALIZZATI NEL METODO "stili_personalizzati()"
//        wp_add_inline_style( EVADBANNER_PREFISSO.self::$ancora_pag, self::stili_personalizzati() );
    }
    private static function carica_scirpt() {
        wp_register_script (EVADBANNER_PREFISSO.self::$ancora_pag, EVADBANNER_PLUGIN_URL.'js/'.self::$ancora_pag.
            '.js', array('jquery-core'),EVADBANNER_JS_ADM_HOME);
        wp_enqueue_script(EVADBANNER_PREFISSO.self::$ancora_pag, false, array(), EVADBANNER_JS_ADM_HOME);

    }
    private static function stili_personalizzati() {
        $css_home  = '.eab-interruttore-banner:HOVER {';
        $css_home .= 'background: url("'.EVADBANNER_PLUGIN_URL.'img/on_off.png") no-repeat scroll 0 0 rgba(0, 0, 0, 0) !important;';
        $css_home .= '}';
        // Remove -------->
        $css_home .= '.fmt-eab-banner-operazioni input[type="submit"] {';
        $css_home .= 'background: url("'.EVADBANNER_PLUGIN_URL.'img/delete.png") no-repeat scroll 0 0 rgba(0, 0, 0, 0);';
        $css_home .= '}';

        $css_home .= '.fmt-eab-banner-operazioni input[type="submit"]:hover {';
        $css_home .= 'background: url("'.EVADBANNER_PLUGIN_URL.'img/delete_hover.png") no-repeat scroll 0 0 rgba(0, 0, 0, 0);';
        $css_home .= '}';

        $css_home .= '.fmt-eab-banner-operazioni input[type="submit"]:active {';
        $css_home .= 'background: url("'.EVADBANNER_PLUGIN_URL.'img/delete_click.png") no-repeat scroll 0 0 rgba(0, 0, 0, 0);';
        $css_home .= 'height: 25px;';
        $css_home .= 'width: 25px;';
        $css_home .= '}';
        // Remove <--------
        // Edit -------->
        $css_home .= '.fmt-eab-banner-operazioni a {';
        $css_home .= 'background: url("'.EVADBANNER_PLUGIN_URL.'img/edit.png") no-repeat scroll 0 0 rgba(0, 0, 0, 0);';
        $css_home .= '}';

        $css_home .= '.fmt-eab-banner-operazioni a:hover {';
        $css_home .= 'background: url("'.EVADBANNER_PLUGIN_URL.'img/edit_hover.png") no-repeat scroll 0 0 rgba(0, 0, 0, 0);';
        $css_home .= '}';

        $css_home .= '.fmt-eab-banner-operazioni a:active {';
        $css_home .= 'background: url("'.EVADBANNER_PLUGIN_URL.'img/edit_click.png") no-repeat scroll 0 0 rgba(0, 0, 0, 0);';
        $css_home .= 'height: 25px;';
        $css_home .= 'width: 25px;';
        $css_home .= '}';
        // Edit <--------

        return $css_home;
    }

    public function form_pagina_home () {
        register_setting (
            self::$ancora_pag.'_gr',   // Option group
            self::$ancora_pag,
            array($this, 'sanitize_pag_'.self::$pagina)      // Sanitize
        );

//        add_settings_section(
//            EVADBANNER_PREFISSO.'sezione_'.self::$pagina, // ID
//            __("Ads Events Banner - Home", EVADBANNER_ANCORA_TRAD), // Title
//            array( $this, 'sezione_'.self::$pagina ),     // Callback
//            self::$ancora_pag                   // Page
//        );
//        add_settings_field(
//            EVADBANNER_PREFISSO.'adm_nome',
//            __("Name", EVADBANNER_ANCORA_TRAD), // Title
//            array( $this, 'input_nome' ),
//            self::$ancora_pag,
//            EVADBANNER_PREFISSO.'sezione_'.self::$pagina
//        );
//        add_settings_field(
//            EVADBANNER_PREFISSO.'adm_cognome',
//            __("Surname", EVADBANNER_ANCORA_TRAD), // Title
//            array( $this, 'input_cognome' ),
//            self::$ancora_pag,
//            EVADBANNER_PREFISSO.'sezione_'.self::$pagina
//        );
    }

    /**
     * Questo metodo è invocato dalla classe "BorSerVal_Admin_Init - carica_menu_exec()" quando crea il menù del plugin
     *
     * e visualizza la pagina Home del plugin
     */
    public function visualizza_pagina_home ($contenuto=NULL) {
//        parent::visualizza_comunicazioni_utente('info', 'Ciao Bello');
        include_once EVADBANNER_PLUGIN_DIR.'admin/'.self::$pagina.'_view.php';
    }

    public function sezione_home() {
        echo '<h1>'.__('Ads Events Banner - Home', EVADBANNER_ANCORA_TRAD).'</h1>';
    }

    public function input_nome() {
        printf(
            '<input type="text" id="id_number" name="'.self::$ancora_pag.'['.EVADBANNER_PREFISSO.'adm_nome]" value="%s" />',
            isset( $this->prova[EVADBANNER_PREFISSO.'adm_nome'] ) ? esc_attr( $this->prova[EVADBANNER_PREFISSO.'adm_nome']) : ''
        );
    }

    public function input_cognome() {
        printf(
            '<input type="text" id="id_number" name="'.self::$ancora_pag.'['.EVADBANNER_PREFISSO.'adm_cognome]" value="%s" />',
            isset( $this->prova[EVADBANNER_PREFISSO.'adm_cognome'] ) ? esc_attr( $this->prova[EVADBANNER_PREFISSO.'adm_cognome']) : ''
        );
    }

    public function sanitize_pag_home ($input) {
//        $messaggio = '';
//        foreach ($input as $chiave => $valore) {
//            $messaggio .= $chiave.': ';
//            if (is_array($valore)) {
//                foreach ($valore as $chiave2 => $valore2) {
//                    $messaggio .= '<br><p style="color: green;">'.$chiave2.': '.$valore2.'</p>';
//                }
//            } else {
//                $messaggio .= sanitize_text_field($valore).'<br><br>';
//            }
//        }
//        parent::aggiungi_messaggio_db('error', $messaggio);
//        return false;

        $tipo_mess = 'error';
        $update    = false;
        if (isset($input['remove'])) {
            if (delete_option(EVADBANNER_ANCORA_CONTENUTO)) {
                $tipo_mess = 'updated';
                $messaggio = __('01 - Successfully deleted !', EVADBANNER_ANCORA_TRAD).
                    ' - <a href="?page='.EvAdBanner_Admin_Init::getPagesName('add').'">'.__('Create one', EVADBANNER_ANCORA_TRAD).'</a>';
            } else {
                $messaggio = __('Oops there was some error deleting, please try again. - Err.Cod. 01', EVADBANNER_ANCORA_TRAD);
            }
            $this->contenuto = parent::$contenuto_iniziale;

        } else {
            if (isset($input['stato_banner']) and 'off' === $this->contenuto['stato_banner']) {
                $this->contenuto['stato_banner'] = 'on';
                $update = true;
            } elseif(!isset($input['stato_banner']) and 'on' === $this->contenuto['stato_banner']) {
                $this->contenuto['stato_banner'] = 'off';
                $update = true;
            }
            if ($this->contenuto['open'] !== sanitize_text_field($input['open'])) {
                $this->contenuto['open'] = sanitize_text_field($input['open']);
                $update = true;
            }
            if (isset($this->contenuto['immagine_show']) and $this->contenuto['immagine_show'] !== sanitize_text_field($input['immagine_show'])) {
                $this->contenuto['immagine_show']= sanitize_text_field($input['immagine_show']);
                $update = true;
            }
        }


        if (true === $update) {
            if (update_option(EVADBANNER_ANCORA_CONTENUTO, $this->contenuto)) {
                $tipo_mess = 'updated';
                $messaggio = __('03 - Successfully updated !', EVADBANNER_ANCORA_TRAD);
            } else {
                $messaggio = __('Oops there was some error updating, please try again. - Err.Cod. 03', EVADBANNER_ANCORA_TRAD);
            }
        }/* else {
            $messaggio = __('It isn\'t changes to updates !', EVADBANNER_ANCORA_TRAD);
        }*/

        if (isset($messaggio)) {
            parent::aggiungi_messaggio_db($tipo_mess, $messaggio);
        }
    }

}