<?php
class EvAdBanner_Settings extends EvAdBanner_Admin {
    private static $ancora_pag;
    private static $pagina = 'settings';
    private static $chiavi_input_concesse = array('privacy', 'fmt-eab-banner-data', 'fmt-eab-banner-testo',
        'fmt-eab-banner-prenota-sx', 'fmt-eab-banner-prenota-dx', 'background-color');


    final public function __construct() {
        if ((isset($_GET['page']) and $_GET['page'] === EvAdBanner_Admin_Init::getPagesName(self::$pagina) or
                strpos($_SERVER['SCRIPT_NAME'], 'options.php')) and is_admin()) {
            parent::__construct();

            add_action('admin_init', array($this, 'form_pagina_' . self::$pagina));
            if (strpos($this->nome_pagina_corrente, '-' . self::$pagina) !== false) {
                add_action('admin_enqueue_scripts', array($this, 'carica_stili_e_script'));
            }

            self::$ancora_pag = EvAdBanner_Admin_Init::getPagesName(self::$pagina);
        }
    }

    final public static function carica_stili_e_script() {
        self::carica_stili();
        self::carica_scirpt();
    }
    private static function carica_stili() {
        wp_register_style (EVADBANNER_PREFISSO.self::$ancora_pag, EVADBANNER_PLUGIN_URL.'css/'.self::$ancora_pag.
            '.css', array(), EVADBANNER_CSS_ADM_HOME);
        wp_enqueue_style (EVADBANNER_PREFISSO.self::$ancora_pag, false, array(), EVADBANNER_CSS_ADM_HOME);

        // AGGIUNGE I STILI PERSONALIZZATI NEL METODO "stili_personalizzati()"
//        wp_add_inline_style( EVADBANNER_PREFISSO.self::$ancora_pag, self::stili_personalizzati() );
    }
    private static function carica_scirpt() {
        wp_register_script (EVADBANNER_PREFISSO.self::$ancora_pag, EVADBANNER_PLUGIN_URL.'js/'.self::$ancora_pag.
            '.js', array('jquery-core'),EVADBANNER_JS_ADM_HOME);
        wp_enqueue_script(EVADBANNER_PREFISSO.self::$ancora_pag, false, array(), EVADBANNER_JS_ADM_SET);

    }
    private static function stili_personalizzati() {
        $css_settings  = '.eab-interruttore-banner:HOVER {';
        $css_settings .= 'background: url("'.EVADBANNER_PLUGIN_URL.'img/on_off.png") no-repeat scroll 0 0 rgba(0, 0, 0, 0) !important;';
        $css_settings .= '}';

        return $css_settings;
    }

    public function form_pagina_settings () {
        register_setting (
            self::$ancora_pag.'_gr',   // Option group
            self::$ancora_pag,
            array($this, 'sanitize_pag_'.self::$pagina)      // Sanitize
        );
    }

    /**
     * Questo metodo è invocato dalla classe "BorSerVal_Admin_Init - carica_menu_exec()" quando crea il menù del plugin
     *
     * e visualizza la pagina Home del plugin
     */
    public function visualizza_pagina_settings ($contenuto=NULL) {
        include_once EVADBANNER_PLUGIN_DIR.'admin/'.self::$pagina.'_view.php';
    }

    public function sanitize_pag_settings ($input) {
//        $messaggio = '';
//        unset($input['submit']);
//        foreach ($input as $chiave => $valore) {
//            if (!isset(parent::$impostazioni_iniziali[$chiave])) {
//                $messaggio = __('You\'re doing something wrong !', EVADBANNER_ANCORA_TRAD);
//                parent::aggiungi_messaggio_db('error', $messaggio);
//
//                return false;
//            }
//            $messaggio .= '<span style="color: blue;">'.$chiave.'</span>: ';
//            if (is_array($valore)) {
//                foreach ($valore as $chiave2 => $valore2) {
//                    $messaggio .= '<p style="color: green;">'.sanitize_key($chiave2).': '.sanitize_text_field($valore2).'</p>';
//                }
//            } else {
//                $messaggio .= sanitize_text_field($valore);
//            }
//        }
//        parent::aggiungi_messaggio_db('error', $messaggio);
//        return false;



        $tipo_mess = 'error';

        if (isset($input['resetta_tutto'])) {
            if (update_option(EVADBANNER_ANCORA_IMPOSTAZIONI, parent::$impostazioni_iniziali)) {
                $this->impostazioni = parent::$impostazioni_iniziali;
                $tipo_mess = 'updated';
                $messaggio = __('The original settings have been restored.', EVADBANNER_ANCORA_TRAD);
            } else {
                $messaggio = __('Oops there was some error on deleting old settings (01), please try again.', EVADBANNER_ANCORA_TRAD);
            }
            parent::aggiungi_messaggio_db($tipo_mess, $messaggio);

            return true;
        }

        unset($input['submit']);
        $errore    = NULL;
        $update    = false;
        foreach ($input as $id_class => $impostaz_css) {
//            $id_class = sanitize_key($id_class);
            $id_class = $id_class;
            if (!isset(parent::$impostazioni_iniziali[$id_class])) {
                $messaggio = __('You\'re doing something wrong !', EVADBANNER_ANCORA_TRAD);
                parent::aggiungi_messaggio_db($tipo_mess, $messaggio);

                return false;
            }

            if (is_array($impostaz_css)) {
                foreach ($impostaz_css as $tipo => $valore) {
                    $tipo   = sanitize_key($tipo);
                    $valore = sanitize_text_field($valore);

                    if (($tipo == 'color' or $tipo == 'colore_1' or $tipo == 'colore_2') and strlen($valore) !== 6) {
                        $errore ['colori'] = true;
                        $messaggio = __('Error - The colors must be in hexadecimal code', EVADBANNER_ANCORA_TRAD);
                        break;
                    } elseif ($tipo == 'num_colori' and !is_numeric($valore)) {
                        $errore ['numeri'] = true;
                        $messaggio = __('Error - The value must be a number', EVADBANNER_ANCORA_TRAD);
                        break;
                    } elseif ($tipo == 'opacity' and ($valore > 1 or $valore < 0)) {
                        $errore ['opacita'] = true;
                        $messaggio = __('Error - The value "opacity" must be between 0 and 1', EVADBANNER_ANCORA_TRAD);
                        break;
                    } elseif ($tipo == 'font-size') {
//                        if ('#beb-eab-banner-cont-prenota-sx a' !== $id_class and '#beb-eab-banner-cont-prenota-dx a' !== $id_class) {
//                            $input[$id_class]['line-height'] = sanitize_text_field($valore);
//                        }
                    }
                    if ($this->impostazioni[$id_class][$tipo] !== $valore) {
                        $this->impostazioni[$id_class][$tipo] = strtolower($valore);
                        $update = true;
                    }
                }
            } else {
                if ($this->impostazioni[$id_class] !== $impostaz_css) {
                    $this->impostazioni[$id_class] = strtolower($impostaz_css);
                    $update = true;
                }
            }
        }

        if (isset($errore['colori']) and isset($errore['numeri']) and isset($errore['opacita'])) {
            $messaggio = __('Error - Colors must be in hexadecimal code; the value must be a number and the value "opacity" must be between 0 and 1 ', EVADBANNER_ANCORA_TRAD);
        } else {
            if (true === $update and !isset($messaggio)) {
                if (update_option(EVADBANNER_ANCORA_IMPOSTAZIONI, $this->impostazioni)) {
                    $tipo_mess = 'updated';
                    $messaggio = __('Settings are successfully updated !', EVADBANNER_ANCORA_TRAD).' - <a href="?page='.EvAdBanner_Admin_Init::getPagesName('add').'">'.
                        __('Create one', EVADBANNER_ANCORA_TRAD).'</a>';
                } else {
                    $messaggio = __('Oops there was some error updating (02), please try again.', EVADBANNER_ANCORA_TRAD);
                }
            } else {
                $messaggio .= __('There isn\'t changes on these settings entered !', EVADBANNER_ANCORA_TRAD);
            }
        }

        parent::aggiungi_messaggio_db($tipo_mess, $messaggio);

        return true;
    }
}